<?php
class redactoractions extends wv40v_action {
	public function redactor_write_phrasesWPfilter($data) {
		$return = array ();
		foreach ( $data as $value ) {
			if ($value ['phrase'] != "" && ! isset ( $value ['delete'] )) {
				$return [$value ['phrase']] = $value;
				if (! is_numeric ( $value ['priority'] )) {
					$return [$value ['phrase']] ['priority'] = 0;
				}
				if ($value ['style'] == 'swap' && $value ['replacement'] == $value ['phrase']) {
					$return [$value ['phrase']] ['style'] = 'blackout';
				}
				if ($value ['style'] != 'swap' && $value ['replacement'] != "") {
					$return [$value ['phrase']] ['replacement'] = '';
				}
			}
		}
		uasort ( $return, array ($this, 'sort_phrases' ) );
		return $return;
	}
	public function sort_phrases($a, $b) {
		$al = strtolower ( $a ['phrase'] );
		$bl = strtolower ( $b ['phrase'] );
		if ($a ['priority'] == $b ['priority']) {
			if ($al == $bl) {
				return 0;
			}
			return ($al > $bl) ? + 1 : - 1;
		} else {
			return ($a ['priority'] < $b ['priority']) ? + 1 : - 1;
		}
	}
	public function initWPaction() {
		wp_enqueue_style ( 'redact_style', $this->application ()->pluginuri () . '/application/public/css/style.css', null, $this->application ()->version () );
	}
	public function redactorWPmenuMeta($return) {
		$return ['Title'] = $this->application()->name;
		return $return;
	}
	public function getting_startedActionMeta($return) {
		$return ['link_name'] = $return ['title'];
		$return ['url'] = $this->help('gettingstarted')->url();
		$return ['classes'] [] = 'v40v_info';
		return $return;
	}
	public function settingsActionMeta($return) {
		$return ['link_name'] = $return ['title'];
		$return ['classes'] [] = 'v40v_settings';
		$return ['priority'] = - 1;
		return $return;
	}
	public function settingsAction() {
		$this->view->censors = $this->application ()->data ()->post ( 'phrases' );
		$this->view->censors [] = $this->application ()->data ()->new_phrase;
	}
	public function comment_textWPfilter($content) {
		return $this->the_contentWPfilter ( $content );
	}
	public function the_contentWPfilter($content) {
		$settings = $this->application ()->data ()->phrases;
		if (! is_array ( $settings )) {
			return $content;
		}
		$tag = bv40v_tag::instance ();
		$content = ' ' . $content . ' ';
		// check for my bbcode tags
		$content = $this->marker ( 'Censor', $content );
		$content = $this->marker ( 'Spoiler', $content );
		// now tokenise all the tags or bbcode tags to stop search and replace breaking anything.
		$tag->tokenise ( $content );
		$cnt = count ( $content->tokens );
		// 2 pass to allow for people trying to swap in bad words 
		for($i = 0; $i < 2; $i ++) {
			foreach ( $settings as $setting ) {
				$token = "#" . str_pad ( $cnt, 4, "0", STR_PAD_LEFT ) . "#";
				//$this->debug($setting);
				$type = $setting ['style'];
				$phrase = $this->preg_safe ( $setting ['phrase'] );
				$pattern = '|[\W](' . $phrase . ')[\W]|Ui';
				preg_match_all ( $pattern, $content->text, $matches, PREG_SET_ORDER );
				foreach ( $matches as $match ) {
					//$this->debug($match);
					$pattern = null;
					switch ($type) {
						case 'blackout' :
							$new_content = $match [1];
							$pwords = $this->words ( $new_content );
							foreach ( $pwords as $pword ) {
								$new_content = preg_replace ( '/\b(' . $pword . ')\b/Ui', $this->blackout ( $pword ), $new_content );
							}
							$pattern = '|' . $match [0] . '|Ui';
							break;
						case 'censor' :
						case 'spoiler' :
							$new_content = $this->$type ( $phrase );
							$pattern = '|\b(' . $phrase . ')\b|Ui';
							break;
						case 'swap' :
							$new_content = $setting ['replacement'];
							$pattern = '|\b(' . $phrase . ')\b|Ui';
							break;
					}
					if (null !== $pattern) {
						$content->tokens [$cnt] = $new_content;
						$content->text = preg_replace ( $pattern, ' ' . $token . ' ', $content->text );
						$cnt ++;
					}
				}
			}
		}
		if ($content->text [0] == ' ') {
			$content->text = substr ( $content->text, 1 );
		}
		$tag->detokenise ( $content );
		return $content;
	}
	
	protected function preg_safe($text) {
		$text = str_replace ( ',', '\W', $text );
		return $text;
	}
	
	public function Censor_Marker($match) {
		$this->view->text = $match ['innerhtml'];
		$page = $this->render_script ( 'redactor/' . strtolower ( $match ['tag'] ) . '.phtml' );
		return $page;
	}
	
	public function Spoiler_Marker($match) {
		return $this->Censor_Marker ( $match );
	}
	
	protected function words($text) {
		// find just words
		$return = array ();
		$words = preg_split ( '|\W|Ui', $text );
		// remove dupes to avaoid problems
		foreach ( $words as $word ) {
			$lword = strtolower ( $word );
			$return [$lword] = $lword;
		}
		return $return;
	}
	
	public function blackout($text) {
		if (strlen ( $text ) == 0)
			return $text;
		$this->view->text = str_repeat ( '&nbsp;&nbsp;', strlen ( $text ) );
		$text = $this->render_script ( 'redactor/blackout.phtml' );
		return $text;
	}
	
	protected function block($text, $tag) {
		if (strlen ( $text ) == 0)
			return $text;
		return $this->censor_Marker ( array ('tag' => $tag, 'innerhtml' => $text ) );
	}
	
	public function censor($text) {
		return $this->block ( $text, 'censor' );
	}
	
	public function spoiler($text) {
		return $this->block ( $text, 'spoiler' );
	}
}
		